#define SRVS_PASSBOOK	0
#define SRVS_CHEQUE	1
#define SRVS_DEPOSIT	2
#define SRVS_CHEQUE_W	3
#define SRVS_ACCOUNT_W	4

#define Q_SIZE		200

#define CUSTOMER	0//0 TO 99 RESERVED FOR CUSTOMERS
#define TELLER		200//200 TO 204 RESERVED FOR TELLERS
#define TELLER1		200
#define TELLER2		201
#define TELLER3		202
#define TELLER4		203
#define TELLER5		204
#define GUARD			205//GUARD
#define SCHEDULER	206//Q SCHEDULER
#define PRINTER		207//REC PRINTER
#define MAIN			208//main thread
#define TIMER			209

#define TIME_T		1
#define TIME_X		TIME_T*13
#define TIME_Y		TIME_T*17
#define TIME_Z		TIME_T*21
#define TIME_B		TIME_T*20
#define TIME_P		TIME_Y*15
#define TIME_A		TIME_T*10


pthread_mutex_t condition_mutex[210];
pthread_cond_t  condition_cond[210];
pthread_t thread_id[210];
int tail[5];
int head[5];
int queue[5][200];
int service_type[200];
int no_cust=10;
int service_requirement;//for the head of queue customer to tell the teller the service time he requires
int questioning_teller;
int cust_srvd=0;
int srvc_time[5];
int cust_no_srvcd[5];

void sleep_wake_it(int s_id,int w_id);
void initialize();
void *f_customer( void *ptr );
void *f_teller( void *ptr );
void *f_rec_prntr( void *ptr );
void *f_q_schdlr( void *ptr );
void *f_guard( void *ptr );
void guard_insert_q(int srvc_type,int c_id);
void print_q();
void *f_timer( void *ptr );
int convert_req_to_time(int req);
void adjust_queue(int q_no);
void schedule_q();


FILE *fp;

pthread_attr_t attr;









